/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * Copyright (C) 2010 Red Hat, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *
 * Author: Jan Görig <jgorig@redhat.com>
 */

#ifndef NSLIST_H
#define NSLIST_H

#include <stdbool.h>
#include <sys/types.h>
#include <netinet/in.h>

typedef struct nslist_item* nslist_item_p;

struct nslist_item
{
	in_addr_t address;
	nslist_item_p next;
};

typedef struct
{
	nslist_item_p head, tail;
	size_t count;
} nslist_t;

void nslist_init(nslist_t *list);
void nslist_free(nslist_t *list);

nslist_item_p nslist_find(nslist_t *list, in_addr_t address);
bool nslist_add(nslist_t *list, in_addr_t address);
bool nslist_compare(nslist_t *list1, nslist_t *list2);
void nslist_move(nslist_t *target, nslist_t *source);

in_addr_t* nslist_serialize(nslist_t *list);

#endif
